﻿using Kivii.Controls;
using Kivii.Zip.Zlib;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Drawing.Imaging;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace Kivii.Sample.ImageUploader
{
    public partial class FrmImageEditor : Form
    {
        private float _zoom = 1f;
        public FrmImageEditor()
        {
            InitializeComponent();
            pictureBox.SelectionBounds = new Rectangle(0, 0, 500, 600);
        }

        public Bitmap backgroundImage;

        public Bitmap ImgEdited;

        private void timeImageEditor_Tick(object sender, EventArgs e)
        {
            FrmMain main = (FrmMain)this.Owner;
            main.setBackgroundImage(ImgEdited);
            this.Close();
        }

        private void FrmImageEditor_Load(object sender, EventArgs e)
        {
            pictureBox.BackgroundImage = backgroundImage;
            pictureBox.BackgroundImageLayout = ImageLayout.Zoom;
            pictureBox.EnableSelection = true;
            resizePictureBox();
        }
        private void btnCancel_Click(object sender, EventArgs e)
        {
            this.Close();
        }
        private void btnSave_Click(object sender, EventArgs e)
        {
            ImgEdited = new Bitmap(GetSelectionImage());

            pictureBox.Refresh();
            timeImageEditor.Enabled = true;
        }
        private void FrmImageEditor_Resize(object sender, EventArgs e)
        {
            resizePictureBox();
        }

        #region 返回图片
        public Image GetSelectionImage()
        {
            return pictureBox.GetSelectionImage(_zoom);
        }
        public void SetSelectionImage(Image img)
        {
            pictureBox.BackgroundImage = img;
            resizePictureBox();
        }
        #endregion

        #region 窗口大小发生变化
        protected override void OnResize(EventArgs e)
        {
            base.OnResize(e);
            resizePictureBox();
        }
        private void resizePictureBox()
        {
            if (pictureBox.BackgroundImage == null) return;
            int width, height;
            if (_zoom == 0f)
            {
                float wzoom = (float)panel.Width / (float)pictureBox.BackgroundImage.Width;
                float hzoom = (float)panel.Height / (float)pictureBox.BackgroundImage.Height;
                _zoom = wzoom < hzoom ? wzoom : hzoom;
            }
            else if (_zoom > 5f) _zoom = 5f;
            else if (_zoom < 0.1f) _zoom = 0.1f;
            width = (int)((float)pictureBox.BackgroundImage.Width * _zoom);
            height = (int)((float)pictureBox.BackgroundImage.Height * _zoom);
            pictureBox.Width = width;
            pictureBox.Height = height;
            int x, y;
            if (panel.Width <= width) x = 0;
            else x = (panel.Width - width) / 2;
            if (panel.Height <= height) y = 0;
            else y = (panel.Height - height) / 2;
            pictureBox.Location = new System.Drawing.Point(x, y);
        }
        #endregion
    }
}
